Package com.io7m.jregions.core.parameterized.areas

# Class PAreaD<S>

java.lang.Object
com.io7m.jregions.core.parameterized.areas.PAreaD<S>

Type Parameters:
  `S` - A phantom type parameter indicating the coordinate space of the area

All Implemented Interfaces:
  `PAreaDType<S>`, `AreaValuesDType`, `AreaSizeValuesDType`

public final class PAreaD<S> extends Object implements PAreaDType<S>

An area with `double` coordinates.

The coordinates of the area are given in half-closed form. That is, `minimumX()` refers to the minimum inclusive value on the X axis, and `maximumX()` refers to the maximum exclusive value on the X axis. Likewise for the Y axis.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `PAreaD.Builder<S>`
  Builds instances of type `PAreaD`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static <S> PAreaD.Builder<S>`
  `builder()`
  Creates a builder for `PAreaD`.
  `static <S> PAreaD<S>`
  `copyOf(PAreaDType<S> instance)`
  Creates an immutable copy of a `PAreaDType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `PAreaD` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`.
  `double`
  `height()`
  Deprecated.
  Use `AreaValuesDType.sizeY()`
  `double`
  `maximumX()`
  `double`
  `maximumY()`
  `double`
  `minimumX()`
  `double`
  `minimumY()`
  `static <S> PAreaD<S>`
  `of(double minimumX, double maximumX, double minimumY, double maximumY)`
  Construct a new immutable `PAreaD` instance.
  `String`
  `toString()`
  Prints the immutable value `PAreaD` with attribute values.
  `double`
  `width()`
  Deprecated.
  Use `AreaValuesDType.sizeX()`
  `final PAreaD<S>`
  `withMaximumX(double value)`
  Copy the current immutable object by setting a value for the `maximumX` attribute.
  `final PAreaD<S>`
  `withMaximumY(double value)`
  Copy the current immutable object by setting a value for the `maximumY` attribute.
  `final PAreaD<S>`
  `withMinimumX(double value)`
  Copy the current immutable object by setting a value for the `minimumX` attribute.
  `final PAreaD<S>`
  `withMinimumY(double value)`
  Copy the current immutable object by setting a value for the `minimumY` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.jregions.core.unparameterized.areas.AreaValuesDType

  `sizeX, sizeY`

  ### Methods inherited from interface com.io7m.jregions.core.parameterized.areas.PAreaDType

  `checkPreconditions`

- ## Method Details

  - ### width

    @Deprecated public double width()
    Deprecated.
    Use `AreaValuesDType.sizeX()`
    Specified by:
      `width` in interface `AreaSizeValuesDType`
    Returns:
      The width of the area

  - ### height

    @Deprecated public double height()
    Deprecated.
    Use `AreaValuesDType.sizeY()`
    Specified by:
      `height` in interface `AreaSizeValuesDType`
    Returns:
      The height of the area

  - ### minimumX

    public double minimumX()
    Specified by:
      `minimumX` in interface `AreaValuesDType`
    Specified by:
      `minimumX` in interface `PAreaDType<S>`
    Returns:
      The value of the `minimumX` attribute

  - ### maximumX

    public double maximumX()
    Specified by:
      `maximumX` in interface `AreaValuesDType`
    Specified by:
      `maximumX` in interface `PAreaDType<S>`
    Returns:
      The value of the `maximumX` attribute

  - ### minimumY

    public double minimumY()
    Specified by:
      `minimumY` in interface `AreaValuesDType`
    Specified by:
      `minimumY` in interface `PAreaDType<S>`
    Returns:
      The value of the `minimumY` attribute

  - ### maximumY

    public double maximumY()
    Specified by:
      `maximumY` in interface `AreaValuesDType`
    Specified by:
      `maximumY` in interface `PAreaDType<S>`
    Returns:
      The value of the `maximumY` attribute

  - ### withMinimumX

    public final PAreaD<S> withMinimumX(double value)
    Copy the current immutable object by setting a value for the `minimumX` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for minimumX
    Returns:
      A modified copy of the `this` object

  - ### withMaximumX

    public final PAreaD<S> withMaximumX(double value)
    Copy the current immutable object by setting a value for the `maximumX` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for maximumX
    Returns:
      A modified copy of the `this` object

  - ### withMinimumY

    public final PAreaD<S> withMinimumY(double value)
    Copy the current immutable object by setting a value for the `minimumY` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for minimumY
    Returns:
      A modified copy of the `this` object

  - ### withMaximumY

    public final PAreaD<S> withMaximumY(double value)
    Copy the current immutable object by setting a value for the `maximumY` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for maximumY
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `PAreaD` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `PAreaD` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static <S> PAreaD<S> of(double minimumX, double maximumX, double minimumY, double maximumY)
    Construct a new immutable `PAreaD` instance.
    Type Parameters:
      `S` - generic parameter S
    Parameters:
      `minimumX` - The value for the `minimumX` attribute
      `maximumX` - The value for the `maximumX` attribute
      `minimumY` - The value for the `minimumY` attribute
      `maximumY` - The value for the `maximumY` attribute
    Returns:
      An immutable PAreaD instance

  - ### copyOf

    public static <S> PAreaD<S> copyOf(PAreaDType<S> instance)
    Creates an immutable copy of a `PAreaDType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Type Parameters:
      `S` - generic parameter S
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable PAreaD instance

  - ### builder

    public static <S> PAreaD.Builder<S> builder()
    Creates a builder for `PAreaD`.

         PAreaD.&lt;S&gt;builder()
            .setMinimumX(double) // required minimumX
            .setMaximumX(double) // required maximumX
            .setMinimumY(double) // required minimumY
            .setMaximumY(double) // required maximumY
            .build();

    Type Parameters:
      `S` - generic parameter S
    Returns:
      A new PAreaD builder